define([],
	function () {
		"use strict";

		/**
		 * Represents a WebCenter group
		 * @param {String} id - Id of the group
		 * @param {String} name - Name of the group
		 */
		var WebCenterGroup = function (id, name) {
			this._id = id;
			this._name = name;
		};

		/**
		 * Get the ID of the group
		 * @returns {String}
		 */
		WebCenterGroup.prototype.getId = function () {
			return this._id;
		};

		/**
		 * Get the name of the group
		 * @returns {String}
		 */
		WebCenterGroup.prototype.getName = function () {
			return this._name;
		};

		return WebCenterGroup;
	});