define([],
	function () {
		"use strict";

		/**
		 * Represents a WebCenter role
		 * @param {String} id - Id of the role
		 * @param {String} name - Name of the role
		 */
		var WebCenterRole = function (id, name) {
			this._id = id;
			this._name = name;
		};

		/**
		 * Get the ID of the role
		 * @returns {String}
		 */
		WebCenterRole.prototype.getId = function () {
			return this._id;
		};

		/**
		 * Get the name of the role
		 * @returns {String}
		 */
		WebCenterRole.prototype.getName = function () {
			return this._name;
		};

		return WebCenterRole;
	});