define([],
	function () {
		"use strict";

		/**
		 * Represents a WebCenter user
		 * @param {String} id - Id of the user
		 * @param {String} name - Name of the user (username)
		 */
		var WebCenterUser = function (id, name) {
			this._id = id;
			this._name = name;
		};

		/**
		 * Get the ID of the user
		 * @returns {String}
		 */
		WebCenterUser.prototype.getId = function () {
			return this._id;
		};

		/**
		 * Get the name of the user (username)
		 * @returns {String}
		 */
		WebCenterUser.prototype.getName = function () {
			return this._name;
		};

		return WebCenterUser;
	});