define(["jquery",
        "underscore",
        "utils/Popup",
        "utils/webi18n!TextContentStrings"],
		function($,
				_,
				Popup,
				webi18n) {
	"use strict";
	
	var AlertPopup = function (popupId, title, bodyText) {
		this._popupId = popupId;
		this._title = title;
		this._bodyText = bodyText;
		
		//Load the languageBundle necessary for this component.
		this._i18n = webi18n;
		
		this._popup = new Popup(this.alertPopup(this._popupID), {minHeight: 'auto'});
		
		this._popup.setTitle(this._title);
		
	};
	
	/**
	 * HTML Creation of the popup
	 * @returns HTML obj
	 */
	AlertPopup.prototype.alertPopup = function() {
		
		var htmlObj = $('<div>').addClass("add-padding").attr("id", this._popupID).append(
			
		$('<div>').append(
				$('<b>').text(this._bodyText)
		),
		
		$('<div>').addClass("add-spacing-top").append($('<span>').attr('id', "alertButtons").append(
				$('<input>').attr({
					'id': "alertOkButton", 
					'type': "button", 
					'value': this._i18n.t("PCM_OK", this._languageBundleName),
					'class': "btn btn-primary"})
					))
		);
		
		return htmlObj;
	};
		
	/**
	 * Opens alert popup with only OK button. A registered call back will be called when user clicks on ok button
	 * @param okCallback
	 */
	AlertPopup.prototype.open = function(okCallback){
		var self = this;
		
		$(document.body).on("click", "#alertOkButton", function() {
			self._popup.close();
			if(undefined != okCallback)
				okCallback();
		});
		
		self._popup.open();			
	};
		
	return AlertPopup;
});