/**
 * @author PASH
 */
define(["jquery",
        "underscore",
        "./ContentStatementElementEditPanelView"],
		function($,
				_,
				ContentStatementElementEditPanelView){
	"use strict";
	
	/**
	 * Constructor to provide content statement edit panel
	 * @param content {String} - Text content string available in the document for current statement element
	 */
	var ContentStatementElementEditPanel = function(content, isEditable) {
		this._view = new ContentStatementElementEditPanelView(content, isEditable);
	};
	
	/**
	 * JQuery object as a wrapper of the edit panel.
	 * @returns
	 */
	ContentStatementElementEditPanel.prototype.getJQElement = function () {
		return this._view.getJQElement();
	};
	
	/**
	 * Method is to get latest content statement.
	 * @returns content {"content" : "text content"} - an object of content statement
	 */
	ContentStatementElementEditPanel.prototype.getCurrentContent = function () {
		var content = {"content": this._view.getCurrentContent()};
		return content;
	};
	

	return ContentStatementElementEditPanel;
});