/**
 * @author PASH
 */
define(["jquery",
        "underscore",
        "./ContentStatementElementEditPanel",
        "./ContentStatementElementMainPanelView"],
		function($, _, ContentStatementElementEditPanel, ContentStatementElementMainPanelView){
	
	"use strict";
	
	/**
	 * Constructor to generate panel, which holds edit and referenced by details panel.
	 * @param contentStatementElement {ContentStatementElement} - object of content statement element to extract content.
	 * @param isEditable {boolean} - user edit permission for current content statement
	 */
	var ContentStatementElementMainPanel = function(contentStatementElement, isEditable) {
		
		// Extract the content from the element.
		var content;
		if (contentStatementElement.content && contentStatementElement.content.content) {
			content = contentStatementElement.content.content;
		} else {
			content = "";
		}
		
		// Preparing edit panel for content statement.
		this._editPanel = new ContentStatementElementEditPanel(content, isEditable);
		this._view = new ContentStatementElementMainPanelView(this._editPanel.getJQElement(), isEditable);
		
	};
	
	ContentStatementElementMainPanel.prototype.getJQElement = function () {
		return this._view.getJQElement();
	};
	
	ContentStatementElementMainPanel.prototype.getCurrentContent = function () {
		return this._editPanel.getCurrentContent();
	};
	
	return ContentStatementElementMainPanel;
});