/**
 * ContentStatement object
 * @author HUBU
 */
define(["./DynContent",
        "../ContentConstants",
		"../ContentStatement",
		"../ContentStatementElement",
		"jquery"
	],
	function (DynContent,
			ContentConstants,
			ContentStatement,
			ContentStatementElement,
			$) {
	
		"use strict";
		
		
		var TextDynContent = function (contentStatementElement, locations) {
			
			// Generate an id for this TextDynContent.
			var elementLang = contentStatementElement.language;
			var elementType = contentStatementElement.parentStatement.elementType;
			var instanceSeq = contentStatementElement.parentStatement.instanceId;
			if (!instanceSeq) {
				instanceSeq = "";
			}
			var random = Math.floor(Math.random()*11);
			var id = elementType+"_I"+instanceSeq+"_"+elementLang+"_"+random;
			// Call the super
			DynContent.call(this, "Text", id);
			
			this._textElement = contentStatementElement;
			if (locations) {
				this._locations = locations;
			} else {
				this._locations = [];
			}
		};
		
		// inherit
		TextDynContent.prototype = Object.create(DynContent.prototype);
		// correct the constructor pointer 
		TextDynContent.prototype.constructor = TextDynContent;
		
		/**
		 * 
		 */
		TextDynContent.prototype.setTextElement = function (textElement) {
			this._textElement = textElement;
		};
		
		/**
		 * 
		 */
		TextDynContent.prototype.getTextElement = function () {
			return this._textElement;
		};
		
		/**
		 * 
		 */
		TextDynContent.prototype.getLocations = function () {
			return this._locations;
		};

		return TextDynContent;
});