define(["underscore",
        "jquery",
        "./ApprovalOverviewWidgetView",
        "utils/webi18n!TextContentStrings",
        "../ContentConstants"],
	function (_, 
			$,
			ApprovalOverviewWidgetView,
			TextContentStrings,
			ContentConstants) {
		
		"use strict";

		/**
		 * Create a widget to display the approval overview. 
		 */
		var ApprovalOverviewWidget = function (contentStatementElement) {
			
			this._csElement = contentStatementElement;
			this._view = new ApprovalOverviewWidgetView(this._csElement.originalApproval);
		};
		
		ApprovalOverviewWidget.prototype.update = function () {
			this._view.update(this._csElement.approval);
		};
		
		ApprovalOverviewWidget.prototype.getJQElement = function () {
			return this._view.getJQElement();
		};
		
		return ApprovalOverviewWidget;
});