define(["underscore",
        "jquery",
        "Template",
        "utils/ConvertUtils",
        "tpl!./ApprovalOverviewWidgetView",
        "utils/webi18n!TextContentStrings",
        "../ContentConstants",
        "utils/webcss!./ApprovalOverviewWidgetStyle.css"],
	function (_, 
			$,
			Template, 
			ConvertUtils,
			tpl,
			textContentStrings,
			ContentConstants,
			ApprovalOverviewWidgetStyle) {
		
		"use strict";

		/**
		 * Create a widget to display the approval overview. 
		 */
		var ApprovalOverviewWidgetView = function (approvals) {
			
			this._callbacks = [];
			
			this._approvalsArr = [];
			// Create the wrapper.
			this._wrapper = $("<div>");
			
			// Create the template
			this._t = new Template(textContentStrings, tpl);
			
			// Add the template to the wrapper.
			this._t.setContext(this._wrapper);
			
			for (var i = 0; i < approvals.length; i++) {
				var formattedTime = ConvertUtils.getLangFormattedDateAndTime(textContentStrings, new Date(approvals[i].ts));
				var approvalObj = {'state':approvals[i].state, 'ts':formattedTime, 'user':approvals[i].user};
				this._approvalsArr.push(approvalObj);
			}
			
			// Assign the formatted approvals in the template
			this._t.d.approvals = this._approvalsArr;
			
			// Render
			this._t.render();
			
		};
		
		ApprovalOverviewWidgetView.prototype.update = function (approvals) {
			// Update the approvals in the template.
			this._t.d.approvals = approvals;
			// Render
			this._t.render();
		};
		
		ApprovalOverviewWidgetView.prototype.getJQElement = function () {
			return this._wrapper;
		};
		
		return ApprovalOverviewWidgetView;
});