/**
 * BindingInfo
 */


define(["./connectioninfo"], function(ConnectionInfo) {
	"use strict";
	
	var BindingInfo = function (json) {
		this._id = json.id;
		this._name = json.name;
		this._status = json.status;
		this._remoteAdress = json.remoteAdress;
		this._localAdress = json.localAdress;
		this._isUpStream = json.isUpStream;
		this._connectionsInfo = [];
		for (var i=0; i < json.connections.length; i++) {
			this._connectionsInfo.push(new ConnectionInfo(json.connections[i]));
		}
	};
	
	BindingInfo.prototype.getId = function () {
		return this._id;
	};
	
	BindingInfo.prototype.getName = function () {
		return this._name;
	};
	
	BindingInfo.prototype.getStatus = function () {
		return this._status;
	};
	
	BindingInfo.prototype.getRemoteAdress = function () {
		return this._remoteAdress;
	};
	
	BindingInfo.prototype.getLocalAdress = function () {
		return this._localAdress;
	};
	
	BindingInfo.prototype.getIsUpstream = function () {
		return this._isUpstream;
	};
	
	BindingInfo.prototype.getConnectionsInfo = function () {
		return this._connectionsInfo;
	};
	
	BindingInfo.prototype.getBandWidthDown = function () {
		var sum = 0;
		for (var i=0; i < this._connectionsInfo.length; i++) {
			sum += this._connectionsInfo[i].getBandWidthDown();
		}
		return sum;
	};
	
	BindingInfo.prototype.getBandWidthUp = function () {
		var sum = 0;
		for (var i=0; i < this._connectionsInfo.length; i++) {
			sum += this._connectionsInfo[i].getBandWidthUp();
		}
		return sum;
	};
	
	BindingInfo.prototype.getPacketsUp = function () {
		var sum = 0;
		for (var i=0; i < this._connectionsInfo.length; i++) {
			sum += this._connectionsInfo[i].getPacketsUp();
		}
		return sum;
	};
	
	BindingInfo.prototype.getPacketsDown = function () {
		var sum = 0;
		for (var i=0; i < this._connectionsInfo.length; i++) {
			sum += this._connectionsInfo[i].getPacketsDown();
		}
		return sum;
	};
	
	return BindingInfo;
});