/**
 * TunnelInfo
 */


define(["./bindinginfo"], function(BindingInfo) {
	"use strict";
	
	var TunnelInfo = function (json) {
		this._id = json.id;
		this._name = json.name;
		this._status = json.status;
		this._errorMsg = json.errorMsg;
		this._bindings = [];
		for (var i=0; i < json.bindings.length; i++) {
			this._bindings.push(new BindingInfo(json.bindings[i]));
		}
		
	};
	
	TunnelInfo.prototype.getId = function () {
		return this._id;
	};
	
	TunnelInfo.prototype.getName = function () {
		return this._name;
	};
	
	TunnelInfo.prototype.getStatus = function () {
		return this._status;
	};
	
	TunnelInfo.prototype.getErrorMsg = function () {
		return this._errorMsg;
	};
	
	TunnelInfo.prototype.getBindingsInfo = function () {
		return this._bindings;
	};
	
	TunnelInfo.prototype.getBandWidthDown = function () {
		var sum = 0;
		for (var i=0; i < this._bindings.length; i++) {
			sum += this._bindings[i].getBandWidthDown();
		}
		return sum;
	};
	
	TunnelInfo.prototype.getBandWidthUp = function () {
		var sum = 0;
		for (var i=0; i < this._bindings.length; i++) {
			sum += this._bindings[i].getBandWidthUp();
		}
		return sum;
	};
	
	TunnelInfo.prototype.getPacketsUp = function () {
		var sum = 0;
		for (var i=0; i < this._bindings.length; i++) {
			sum += this._bindings[i].getPacketsUp();
		}
		return sum;
	};
	
	TunnelInfo.prototype.getPacketsDown = function () {
		var sum = 0;
		for (var i=0; i < this._bindings.length; i++) {
			sum += this._bindings[i].getPacketsDown();
		}
		return sum;
	};
	
	return TunnelInfo;
});
    