/**
 * TunnelMonitorService
 *
 * @author KADA
 * @since 9.2.2015
 */
define(["jquery","./data/tunnelinfo"], function ($, TunnelInfo) {
	
	"use strict";
	
	var TunnelMonitorService = (function (){
			
			// Instance stores a reference to the Singleton
			var instance;
			
			function init() {
				
				// The baseUrl of the service.
		        var jspBaseUrl = window.webcenterConfig.jspBaseUrl;
				
				return {
					
					getTunnelMonitorInfoFor : function (clientName, onSuccesCallback, onFailCallback) {
						
						// Do the async call to the service
						$.ajaxSetup({ cache: false });
	            		$.getJSON( jspBaseUrl+"tunnelmonitor.wcr?"+$.param({action:"GET_TUNNEL_INFO", client:clientName}), function( data ) {
	            			
	            			var timeStamp = data.timeStamp;
	            			var tunnelInfos = [];
	            			for (var i=0; i < data.tunnelInfos.length; i++) {
	            				tunnelInfos.push(new TunnelInfo(data.tunnelInfos[i]));
	            			}
	            			
	            			onSuccesCallback(tunnelInfos, timeStamp);
	            			
	                	}).fail(function(jqxhr, textStatus, error) {
	                		// Try to parse the error.
	        	    		var msg;
	        	    		try {
	        	    			msg =JSON.parse(jqxhr.responseText).error.message;
	        	    		} catch (e) {
	        	    			msg = error;
	        	    		}
	        	    		// Execute the callback.
	                		onFailCallback(msg);
	                	});
					}
				};
			}
			
			return {
				// Get the Singleton instance if one exists
				// or create one if it doesn't
				getInstance : function() {
					if (!instance) {
						instance = init();
					}
					return instance;
				}
			};
	})();
	    
	return TunnelMonitorService;

});