/**
 * TunnelMonitor View
 *
 * @author KADA
 * @since 9.2.2015
 */
define(["jquery"], function ($) {
	
	"use strict";
	
	var TunnelMonitorUtil = {	

		/**
		 * 
		 * @param bps
		 */
		formatBps : function (bps) {
			 
			var unit = "b/s";
			var num = bps;
			
			var Kbs = bps/1000;
			var Mbs = Kbs/1000;
			var Gbs = Mbs/1000;
			
			if (Gbs > 1) {
				num = parseFloat(Math.round(Gbs * 100) / 100).toFixed(2);
				unit = "Gb/s";
			} else if (Mbs > 1){
				num = parseFloat(Math.round(Mbs * 100) / 100).toFixed(2);
				unit = "Mb/s";
			} else if (Kbs > 1){
				num = parseFloat(Math.round(Kbs * 100) / 100).toFixed(2);
				unit = "Kb/s";
			} else {
				num = parseFloat(Math.round(bps * 100) / 100).toFixed(2);
				unit = "b/s";
			}			
			return  $("<span class='VariableNumber'>"+num+"</span>&nbsp;<span class='VariableUnit'>"+unit+"</span>");
		},
	
		/**
		 * 
		 * @param ps
		 */
		formatPs : function (ps) {
			return  $("<span>(<span class='VariableNumber'>"+ps+"</span>&nbsp;<span class='VariableUnit'>p/s</span>)</span>");
		}
	};
	
	return TunnelMonitorUtil;
	
});