/*
 * TODO:
 * 
 * - Mismatch of link == by reference and link == document to a task!!!
 * - Validation not adapted yet!
 * 
 * 
 * 
 */


define(["wcr/webcenter_html",
        "attributecategory/AttributeCategory",
        "./PageSection",
       	"jquery",  
        "wcr/documentSourceHandler",
        "doctablex/DocTableXFactory",
        "doctablex/DocTableXUtils",
        "doctablex/DocTableXRenderConfig",
        "doctablex/StaticDocumentRow", 
        "doctablex/AJAXDataCache",
        "doctablex/TextContent", // avoid this?
        "doctablex/TextContentRow", // avoid this?
        "utils/EventBasedValidator",
        "utils/webi18n!ACatStrings",
        "utils/webi18n!DocSrcHdlrStrings",
        "component/smartnames/savedsearchcontext/SavedSearchContextInfo",
//        "wcr/AddDocument",
//        "wcr/DocumentsTable",
        "wcr/validate"], 
function(WCHTML, 
		AttributeCategory, 
		PageSection, 
		$,
        DocumentSourceHandler,
        docTableXFactory,
        DocTableXUtils,
        DocTableXRenderConfig,
        StaticDocumentRow,
        AJAXDataCache,
        TextContent,
        TextContentRow,
		EventBasedValidator,
		ACatStrings,
		DocSrcHdlrStrings,
		SavedSearchContextInfo) {
	
	/**
	*	DocumentsSection constructor (subclass of PageSection)
	* 
	* PageSection serves as a generic superclass of various page sections used within task execution page
	* and others.
	*/
	function DocumentsSection(sectionID, expandToggleID, bodyID, data, state)
	{
		// call superclass constructor with parameters containing IDs of main elements of the section
		PageSection.call(this, sectionID, expandToggleID, bodyID, state);
		
		// whether is this section enabled by task type
		this.enabled = data.enabled;

		this.readOnly = true;
		
		this.currentUser = ObjectHandler.getCloneOfObject(window.gCurrentUser);
		// ('this.currentUser.canEditAttributes' is set in initialize() method.)
		
		this.docSavedSearchNameList = data.docSavedSearchNameList || [];

		this.taskTypeName = data.taskTypeName || '';
		
		this.projectID = data.projectID || '';
		
		this.docList = data.docList || [];
		
		this.showThumbnails = data.showThumbnails || false;
		
		// default attribute category for all documents uploaded on TEP
		this.defTaskDocAttrCatID = data.defTaskDocAttrCatID || '';
		
		// name of default target folder for all documents uploaded on TEP.
		// Note '' (empty string) is for root folder so it's better to initialize to null in case of no value...
		this.defTaskDocFolderName = data.defTaskDocFolderName || null;
	}

	// define DocumentsSection as a subclass of PageSection
	DocumentsSection.prototype = new PageSection;


	DocumentsSection.prototype.initialize = function(name)
	{
		PageSection.prototype.initialize.call(this, name);
		// set a flag defining whether this task's section is modifiable
		this.readOnly = (this.parent.isTaskCompleted || !this.parent.isChangeable || !this.enabled);
		
		// one of the prerequisities for logged in user to be able to edit the root DocTableX is 
		// editability of (in this case) virtual parent attribute category. The DocTableX
		// holding all documents linked to this task is actually the value of the only attribute 
		// of this virtual attribute category.
		this.currentUser.canEditAttributes = !this.readOnly;
		
		// rendering configuration
		// -----------------------
		// create the documents table rendering configuration object for TEP
		var docTableRenderConfigObj = new DocTableXRenderConfig({
			defaultName : 'Custom Rendering Configuration',
			section : 'TaskDocuments',
			phElemID : 'DocRenderConfigDivID',
			defaultAttrCatView : this.taskTypeName,
			configObj : null,   // default configuration will be generated
//					attributes : this.attributes,   // this is all attributes in the system
//					properties : docRefProperties,   // this is just attributes in reference attribute category
			changeCallback : function() {this.modified = true;}.bind(this)
		});

		// get render configuration XML. If there is no XML, the default configuration for the given section 
		// ('TaskDocuments' in this case) will be used.
		var docRenderConfigXML = $('#DocRenderConfigXML').val();
		if (docRenderConfigXML) {
			// load the rendering configuration from provided XML (if any)
			docTableRenderConfigObj.readFromXMLString(docRenderConfigXML);
		}

		// get the configuration itself
		var docTableRenderOptions = docTableRenderConfigObj.getConfigObj();
		
        // add system-wide configuration options
        docTableRenderOptions.showThumbnails = this.showThumbnails;
		
		// add few more implicit (not configurable) render options
		docTableRenderOptions.renderMethod = 'table';
        docTableRenderOptions.showGreenLinksOnTop = true;
        docTableRenderOptions.showGreenLinksAtBottom = false;
        
        
		// document sources
		// ----------------
        var docSourceXML = $('#documentSourcesTextArea').val();
        var docSourcePHElemID = 'documentSourcesHiddenDiv';
        
		// initialize the SavedSearchContextInfo required for intermediate value injection for Saved Search with Smart Names
		var savedSearchContextInfo = new SavedSearchContextInfo();
		savedSearchContextInfo.setProjectId(this.projectID);
		//JAMI: leave out the TaskSpecificationsDynamicSmartNameCollector for now as we don't have Task-context Smart Names available at the moment

        var dshObj = new DocumentSourceHandler({
            docSourceXML : docSourceXML,
            docSourceTableId : docSourcePHElemID,   // configuration table can be only one on a page
            functionPrefix : 'javascript:document.getElementById(\'' + docSourcePHElemID + '\').dshObj',			
            prefix : '',   // prefix used in configuration part			
            currentLanguage : (this.currentUser) ? this.currentUser.lang : null,  // language code of the current userAgent
            textClass : 'darktext_greenlink_11',
            linksId : null,   // managed by DocTableX internally
            isDocReferenceSection : false,   // makes visible the "By reference" document source
            docSavedSearchNameList : this.docSavedSearchNameList,
            savedSearchContextInfo : savedSearchContextInfo
        }, DocSrcHdlrStrings);

        if (!docSourceXML) {
            // set the WebCenter defaults		
            var section = 'TaskExecutionPage';
            dshObj.setWebCenterDefault(section);
        }
        
		// documents table
		// ---------------
        this.docTableObj = docTableXFactory.createDocTableX({
            dshObj : dshObj,   // link between DocTableX and DocumentSourceHandler objects
            prefix : 'TaskDocuments',   // main prefix to be used by this DocTableX instance
            phElemID : this.bodyID,   // HTML element ID, where this doc table will be put
            aCatView : this.taskTypeName,   // this is the only supported view (in context of TEP)
            saveXMLRootTag : 'drs',
            onChangeCallback : function() {this.setModified(true);}.bind(this),
            autoExpandAllRows : true,
            currentUser : this.currentUser,
            isEditable : !this.readOnly,
            allowMultiple : true,
            showGreenLinksOnTop : true,   // specific for document reference attributes. normal upload has the "green links" only at the bottom
            projectID : this.projectID,
            defTaskDocAttrCatID : this.defTaskDocAttrCatID,   // task (execution page) specific
            defTaskDocFolderName : this.defTaskDocFolderName,   // task (execution page) specific
            onBeforeDownloadAction : function() {this.downloaDoc = true;}.bind(this.parent),
            renderOptions : docTableRenderOptions
        });
        

        // set special set of click methods for document references
        // (can be done only now as both dshObj and this.docTableObj instances needs to be initialized)
        // (it's not in the DocTableX constructor as DocTableX can be used in different use cases than doc. refs.)
        dshObj.setAdvancedClickMethods('TaskExecutionPage', this.docTableObj.thisInDOM);

        for (var i = 0; i < this.docList.length; i++) {
        	var aDoc = this.docList[i];
        	var docInfo = {};
            docInfo.docVerID = aDoc.docverid;
            docInfo.docID = aDoc.id;
            docInfo.docName = aDoc.name;
            docInfo.docDesc = aDoc.description;
            docInfo.aCatID = aDoc.categoryid;

	        // create the row instance and append it to the documents table
	        this.docTableObj.appendDocRow(docInfo, StaticDocumentRow, false);
        }
        
        
	    if ((this.docTableObj.getNumberOfRows() == 0) && (!this.enabled)) {
    		// hide the whole section if there are no documents and it's disabled by its task type
    		this.setState("HIDE");
		}
	};

	
	DocumentsSection.prototype.isModified = function() 
	{	
		// wctask documents section is modified also when a new document was added (gDocumentRowIds.length > 0)
		if(this.modified || (gDocumentRowIds.length > 0)){
			this.modified = true;
			return true;
		} 
		
		// check document's attribute categories. If they exist (task view exists), validate
		if (this.uploadedDocsNumber > 0) {
			for(var i=0 ; i<this.uploadedDocsNumber ; i++){
				// myACatArr is a global that should be already defined (see "wctaskexectionpage.xsl").
				if(window.myACatArr[i]){
					// always validate if there's a category
					this.modified = true; // for future checks
					return true;
				}
			}
		}
		
		//check if there is some document version for upload(indicated by unfolded upload row)
		if ($("[name^='newVersionDocFile_']:not([disabled])").length > 0) {
			return true;
		}
		return false;
	};

	DocumentsSection.prototype.validateFormParams = function(force)
	{
		var MAX_ERROR_MESSAGES = 20;
		
		//this variable is here because of jQuery validation of comment of uploading new doc version. Simple "return false" in tha place would not work for firefox 
		var isValidated = true;
		var action = $("#actionValId").val();
		
		if (action && (action == "ChangeTaskOnExecutionPage"))
		{
    		// initialize the validation object ('validObj') in case of the root of the doc. ref. tree structure.
    		// object holding all found validation errors together with the related data needed to notify user.
    		validObj = {
   	    		errors : [],   // array of error objects containing: 
   	    					   // 'level', 'element', docRowObj and 'msg' or 'attrLabel' members
	    		isOK : function() {   // function returning true if no problem found during validation
	    			return (this.errors.length == 0);
	    		}, 
	    		newDocs: [],
	    		newDocsDOMElems: {}
	    	};
        	var depth = 1;
        	
        	
        	// validate the whole documents table in Task Documents section
			this.docTableObj.validateDocTable(validObj, depth);
			
			// process the validation result if everything is not OK
			if (!validObj.isOK()) {
				//JANH TODO!!! This should be a method of validObj or something...
        		var errorMsg = '';
        		var firstReportedIssueIdx = -1;
				
        		// if the validation is not OK and we are at the root level, run over 
        		// all the found problems and add them to the 'errorMsg' displayed
        		// as the result of the whole validation process. the blocking issues have priority
        		for (var passNum = 1; passNum < 3; passNum++) {
	        		for (var errIdx = 0; errIdx < validObj.errors.length; errIdx++) {
	        			var errObj = validObj.errors[errIdx];
	        			if (passNum == 1) {
	        				// in first pass skip all non-blocking issues
	        				if (!errObj.isBlocking) continue;
	            			// if a blocking problem found, make sure the user is not allowed to save the changes
	            			force = true;
	        			} else {
	        				// in second pass skip already processed blocking issues
	        				if (errObj.isBlocking) continue; 
	        			}
	        			// remember the index of the first reported problem
	        			if (firstReportedIssueIdx < 0) firstReportedIssueIdx = errIdx;
	        			
				    	// protection against too many validation error messages in the alert/confirm dialog
					    if (errIdx < MAX_ERROR_MESSAGES) {
		        			// add the current error message
		        			if (errObj.msg) {
		        				errorMsg += '\n' + errObj.msg;
		        			} else if (errObj.attrLabel) {
		        				errorMsg += '\n' + ACatStrings.t('ACatRequiredAttribute') + ' ' + errObj.attrLabel + ' ' + ACatStrings.t('ACatRequiredButNull');
		        			}
					    } else if (errIdx == MAX_ERROR_MESSAGES) {
		        			errorMsg += '\n...';
					    }
	        			if (errObj.element) {
						    // highlight the (jQuery) element in yellow
						    errObj.element.addClass('validationHighlight');
	        			}
					    if (errObj.docRowObj) {
						    // make sure all attribute categories, where a validation problem was found are expanded
					    	// (applicable only for document reference attributes)
					    	errObj.docRowObj.expandBranchTillThis(errObj.level);
					    }
	        		}
        		}

				force = (force || ($('#taskStatusInput').val() == "00001_0000000003")); // if status changed to completed manually, it has to force attribute category to be valid (required attributes filled out)
				if (force) {
					isValidated = false;
					alert(window.taskExPage.langArr.WCTASK_VALIDATION_ERROR + '\n' + errorMsg);
				} else {
               		isValidated = confirm(window.taskExPage.langArr.WCTASK_VALIDATION_CONFIRM + '\n' + errorMsg);
				}
			}
			
		}
			
		if (isValidated) {
			this.docTableObj.onSubmit();
		}
		
		// validation of document attributes went OK
		return isValidated;
	};

	DocumentsSection.prototype.show = function()
	{
		try {
			PageSection.prototype.show.call(this);
		}
		catch (err) {
			alert("Problem in DocumentsSection.show() method: " + err);
		}
	};

	DocumentsSection.prototype.generateDynamicContent = function()
	{
		try {
			// the wctask attributes was already generated - skip it
			if (this.dynamicContentReady) return;

			//JANH TODO!!! as the "dynamic content" consists of documents table, a ?problem? 
			// here might be there is no "is ready" concept in DocTableX as it is  e.g. in AttributeCategory...
			
			// render the documents table
			this.docTableObj.displayTable();
			
			// dynamic content of this section generated		
			this.dynamicContentReady = true;
		}
		catch (err) {
			alert("Problem in DocumentsSection.generateDynamicContent() method: " + err);
		}
	};

	DocumentsSection.prototype.hideNewDocsTable = function()
	{
		try {
			var newDocsTable = $("#newDocumentsBlockId");
			if (newDocsTable.length == 0) return;
			
			newDocsTable.hide();
		}
		catch (err) {
			alert("Problem in DocumentsSection.hideNewDocsTable() method: " + err);
		}
	};

	DocumentsSection.prototype.uploadMultipleDocsClicked = function()
	{
		try {
			$("#actionValId").val("UploadMultipleDocumentToProjectAndTask");
			if ($("#actionformId").length > 0) {
				try {				
			$("#actionformId").submit();
		}
				catch (IEerr) {
					// When a page loading action initiated by JavaScript is cancelled by the onbeforeunload event
					// IE will throw an exception. Too bad there's no way to identify this specific exception
					// so ignore exceptions on form submission
				}
			}
		}
		catch (err) {
			alert("Problem in DocumentsSection.uploadMultipleDocsClicked() method: " + err);
		}
	};


	return DocumentsSection;
	
});