/**
 * TunnelService
 *
 * @author KADA
 * @since 26.2.2015
 */
define(["jquery","component/smartnames/encoding/smartname"], function ($, SmartName) {
	
	"use strict";
	
	var TunnelService = (function (){
			
			// Instance stores a reference to the Singleton
			var instance;
			
			function init() {
				
				// The baseUrl of the service.
		        var jspBaseUrl = window.webcenterConfig.jspBaseUrl;
				
				return {
					
					getBindingSmartNames : function (onSuccesCallback, onFailCallback) {
						
						// Do the async call to the service
						$.ajaxSetup({ cache: false });
	            		$.getJSON( jspBaseUrl+"tunnelmonitor.wcr?action=GET_BINDING_SMARTNAMES", function( data ) {

	            			var smartNames = [];
	            			for (var i=0; i < data.length; i++) {
	            				smartNames.push(new SmartName(data[i].name, data[i].arguments));
	            			}
	            			
	            			onSuccesCallback(smartNames);
	            			
	                	}).fail(function(jqxhr, textStatus, error) {
	                		// Try to parse the error.
	        	    		var msg;
	        	    		try {
	        	    			msg =JSON.parse(jqxhr.responseText).error.message;
	        	    		} catch (e) {
	        	    			msg = error;
	        	    		}
	        	    		// Execute the callback.
	                		onFailCallback(msg);
	                	});
					}
				};
			}
			
			return {
				// Get the Singleton instance if one exists
				// or create one if it doesn't
				getInstance : function() {
					if (!instance) {
						instance = init();
					}
					return instance;
				}
			};
	})();
	    
	return TunnelService;

});