define(["jquery",
        "underscore"], 
function($, 
		 _){
    "use strict";
    
    /**
     * Simple util class which caches (jQUery) Ajax calls.
     * Just use it as if you would use $.ajax
     */
    var AjaxCache = (function(){
    	var cachedFunction = _.memoize($.ajax, function(options){
    		return JSON.stringify(options);
    	});
        
        return {
        	ajax: cachedFunction
        };
    })();
    
    return AjaxCache;
});
