define([],
	function () {
		"use strict";

		return {
			/**
			 * Converts an integer (0 to 16581375) into a RGB color string (e.g. #012345)
			 * @param   {Number} colorInt
			 * @returns {String}
			 */
			intToHexString: function (colorInt) {
				var r = Math.floor(colorInt / (255 * 255)).toString(16);
				var g = Math.floor(colorInt / 255).toString(16);
				var b = Math.floor(colorInt % 255).toString(16);
				return "#" + (r.length == 1 ? "0" + r : r) + (g.length == 1 ? "0" + g : g) + (b.length == 1 ? "0" + b : b);
			},
			/**
			 * Converts RGB values (numbers 0 to 255) into a RGB color string (e.g. #012345)
			 * @param   {Number} r
			 * @param   {Number} g
			 * @param   {Number} b
			 * @returns {String}
			 */
			rgbToHexString: function (r, g, b) {
				r = r.toString(16);
				g = g.toString(16);
				b = b.toString(16);
				return "#" + (r.length == 1 ? "0" + r : r) + (g.length == 1 ? "0" + g : g) + (b.length == 1 ? "0" + b : b);
			}

		};
	});