define(["jquery",
		"underscore",
        "utils/ConvertUtils"],
	function ($,
		_,
		ConvertUtils) {
		"use strict";

		var HTTPUtils = {
			/**
			 * Construct an url (with urlencoded arguments)
			 * @param servlet {String} the servlet to call
			 * @param args {Object} parameters for url (key-value pairs)
			 * @param base {String} url (optional)
			 * @returns {String}
			 */
			constructURL: function (servlet, args, base) {
				var url = "";
				if (base) {
					url += base;
				}
				url += servlet;

				var pre = "?";
				for (var key in args) {
					if (args.hasOwnProperty(key)) {
						if (_.isArray(args[key])) {
							for (var i = 0; i < args[key].length; i++) {
								url += pre + encodeURIComponent(key) + "=" + encodeURIComponent(ConvertUtils.decodeHtmlEntities(args[key][i]));
								pre = "&";
							}
						} else {
							url += pre + encodeURIComponent(key) + "=" + encodeURIComponent(ConvertUtils.decodeHtmlEntities(args[key]));
						}
					}
					pre = "&";
				}


				return url;
			}
		};

		return HTTPUtils;
	});