define([], 
function(){
    "use strict";

    var MethodExtender = (function(){
    	/**
         * Extend a method by executing a passed method after the rendering
         * The passed method will be called with the extended object (to avoid 'this' conflicts), 
         * followed by same arguments as the regular method call
         */
    	var extend = function(object, methodName, extendFn){
    		var oldMethod = object[methodName];
    		object[methodName] = function(){
    			var res = oldMethod.apply(this, arguments);
    			
    			var newArgs = [this].concat(arguments);
    			extendFn.apply(this, newArgs);
    			
    			return res;
    		};
    	};
    	
        return {
        	extendMethod: extend
        };
    })();
    
    return MethodExtender;
});
