define(["underscore",
		"web-viewer/compare/CompareMode",
		"web-viewer/compare/CompareConstants"
	],
	function (_,
		CompareMode,
		CompareConst) {
		"use strict";

		/**
		 * @memberof CompareModule
		 * @exports CompareShowDifferenceMode
		 * @class Deadsimple compare mode just showing the difference document
		 * @constructor
		 * @param {Core.ViewerFacade} f
		 * @param {CompareModule.CompareModel} compareModel - model for compare
		 */
		var CompareShowDifferenceMode = function (f, compareModel) {
			CompareMode.call(this, f, CompareConst.mode.SHOW_DIFFERENCE, compareModel, false, "AnnDisabledDiffMode", "difference");
		};

		CompareShowDifferenceMode.prototype = Object.create(CompareMode.prototype);
		CompareShowDifferenceMode.prototype.constructor = CompareShowDifferenceMode;

		/**
		 * Start/stop show compare mode
		 * @override
		 */
		CompareShowDifferenceMode.prototype.toggle = function (toggle) {
			CompareMode.prototype.toggle.call(this, toggle);
			this._compareModel.setDiffMode(toggle ? CompareConst.diffMode.DIFFVERSION : CompareConst.diffMode.UNDEFINED);
		};

		return CompareShowDifferenceMode;
	});