<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
  <!ENTITY copy "&#169;">
  <!ENTITY nbsp "&#160;">
  <!ENTITY lk "/webcenter_page/user_lang_key">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format"
                xmlns:java="http://xml.apache.org/xslt/java" xmlns:XSLUtils="com.esko.webcenter.jsp.XSLUtils" xmlns:Lang="com.esko.webcenter.jsp.LanguageMgr"
	exclude-result-prefixes="XSLUtils java Lang">
  <xsl:import href="template.xsl"/>
  <xsl:import href="docdetails_template.xsl"/>
  <xsl:import href="attributetemplates.xsl"/>
  <xsl:import href="templatedate.xsl"/>
  
	<xsl:variable name="useTableBodyContainer" select="false()" />
  
 
  
  
  

  <xsl:template name="bodyextensions">
    <xsl:attribute name="onload">SetInitialFocus();</xsl:attribute>
  </xsl:template>

    <xsl:variable name="isEditable" select="(/webcenter_page/is_editable = 'true') or (/webcenter_page/is_editable = '1')"/>
	  
  <!-- 
  
            template that controls the generation of the body header
            
  -->
  <xsl:template name="bodyheader">
  	<!--  no body header --> 
  </xsl:template>
  <xsl:template name="pagesubtitle">
  	 <xsl:variable name="catDisplayName">
        <xsl:choose>
          <xsl:when test="category/name"><xsl:value-of select="category/name"/></xsl:when>
          <xsl:otherwise>---</xsl:otherwise>
        </xsl:choose>
    </xsl:variable>
    <xsl:variable name="catDisplayViewName">
        <xsl:choose>
          <xsl:when test="/webcenter_page/attrcatview"><xsl:value-of select="/webcenter_page/attrcatview"/></xsl:when>
          <xsl:otherwise><xsl:value-of select="Lang:getStr(&lk;, 'ACLayoutDefault')"/></xsl:otherwise>
        </xsl:choose>
    </xsl:variable>
    
    
	<xsl:call-template name="DetailsAttributeHeader">
		<xsl:with-param name="catDisplayName" select="$catDisplayName"/>
		<xsl:with-param name="catDisplayViewName" select="$catDisplayViewName"/>
		<xsl:with-param name="isEditable" select="$isEditable and not(/webcenter_page/attrcatview)"/>
		<xsl:with-param name="changeActionValue" select="'SaveAttributes'" />
		<xsl:with-param name="showPrintButton" select="true()" />
		
		<!-- when we are in a custom view, override the header with the label of the menu -->
		<xsl:with-param name="useLabelOfDetailsMenu" select="boolean(/webcenter_page/attrcatview)"/>
	</xsl:call-template>
  </xsl:template>
  
  
  <!-- 
  
            template that controls the generation of the body content
            
  -->
  <xsl:template name="bodycontent">
	<xsl:variable name="dynamicAttr" select="category/category_XML"/>

 	 <!-- Confirmation section -->
	  <xsl:call-template name="DisplayNotification"/>
	  <xsl:call-template name="DisplayAttrSaveNotification"/>	
	  
    <xsl:choose>
    	<!-- No Category assigned : display the appropriate message -->
    	<xsl:when test="no_attr_category_msg">
    		<div class="alert alert-info" role="alert">
    			<xsl:value-of select="Lang:getStr(&lk;,'DOCHASNOATTRSCATEGORY_TAG')"/>
    		</div>
    	</xsl:when>
    	<xsl:otherwise>
					<form name="actionform" method="post" action="dodocdetailsactions.jsp" enctype="MULTIPART/FORM-DATA" class="wcr-form">	
						<input type="hidden" name="actionVal" value="SaveAttributes"/>
						<input type="hidden" name="attributeCategoryReturnPage">
							<xsl:if test="boolean(/webcenter_page/attrcatview)">
								<xsl:attribute name="value"><xsl:value-of select="/webcenter_page/attrcatviewreturnurl"/></xsl:attribute>
							</xsl:if>
						</input>
						<xsl:call-template name="docDetailsHiddenInputs"/>

						<!-- firefox needs submit button for actual submission -->
	 					<input type="submit" style="display:none;" />

						<div id="ACatObj"></div>
						<div id="ACatPanel"></div>
					</form>
    	</xsl:otherwise>
    </xsl:choose>


  	<xsl:call-template name="AttributeActionButtons">
  		<xsl:with-param name="action" select="'dodocdetailsactions.jsp'"/>
  		<xsl:with-param name="importActionValue" select="'ImportDocumentAttrsFromXML'"/>
  		<xsl:with-param name="exportActionValue" select="'ExportDocumentAttrsToXML'"/>
  		<xsl:with-param name="changeActionValue" select="'SaveAttributes'" />
  		<xsl:with-param name="inputTemplateName" select="'docDetailsHiddenInputs'"/>
		<xsl:with-param name="showImportExportFunctionality" select="not(/webcenter_page/attrcatview) and ($isEditable = 'true')"/>
  	</xsl:call-template>
    
	 
  </xsl:template>
  
  <xsl:template name="changeCategoryHref">
    <xsl:call-template name="docDetailsHref">
      <xsl:with-param name="page" select="'docdetailsattrscategory.jsp'"/>
    </xsl:call-template>
  </xsl:template>


    
  <!-- 
  
            template that controls the inclusion of javascript functionality 
            
  -->
  <xsl:template name="scriptincs">
    <script src="javascript/validate.js"/>&#xA;
	<script src="javascript/TableSelection.js"/>&#xA;
    <style>
      #ui-datepicker-div
      {
      z-index: 9999999;
      }
    </style>
    <script type="text/javascript">
      <xsl:text disable-output-escaping="yes">&lt;!--</xsl:text>&#xA;
		function OpenNewWindow(href)
		{
		  window.open(href);
		}
		
        function PrintWindow(newWindow)
        {
			var location = '';
			if (newWindow)
				location += 'javascript:OpenNewWindow("';
			location += 'docdetailsattrs.jsp?docVerID=<xsl:value-of select="/webcenter_page/doc_version/@id"/>'; 
			<xsl:if test="count(/webcenter_page/attrcatview)>0">
				location += '&amp;attrcatview=<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="/webcenter_page/attrcatview"/></xsl:call-template>';
			</xsl:if>						 
			<xsl:if test="count(/webcenter_page/pagetitle)>0">
				location += '&amp;pagetitle=<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="/webcenter_page/pagetitle"/></xsl:call-template>';
			</xsl:if>						 
			<xsl:if test="count(/webcenter_page/showimage)>0">
				location += '&amp;showimage=<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="/webcenter_page/showimage"/></xsl:call-template>';
			</xsl:if>						 
			<xsl:if test="count(/webcenter_page/maxpixsize)>0">
				location += '&amp;maxpixsize=<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="/webcenter_page/maxpixsize"/></xsl:call-template>';
			</xsl:if>						 
			<xsl:if test="count(/webcenter_page/maxpixsizex)>0">
				location += '&amp;maxpixsizex=<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="/webcenter_page/maxpixsizex"/></xsl:call-template>';
			</xsl:if>						 
			<xsl:if test="count(/webcenter_page/maxpixsizey)>0">
				location += '&amp;maxpixsizey=<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="/webcenter_page/maxpixsizey"/></xsl:call-template>';
			</xsl:if>						 
			if (newWindow)
				location += '&amp;print=1");';
			else
				location += '&amp;print=1&amp;menu_file=<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="/webcenter_page/menu_file"/></xsl:call-template>';
//			alert(location);
			window.location = location;
						
			return;  				
        }
        
		<xsl:if test="/webcenter_page/doc_version/category_id">
		
		require(["attributecategory/AttributeCategory"], function(AttributeCategory){
			$(document).ready(function() {
				<!-- aCatOptions.projectID is project ID for projects and template ID for templates. -->
			    <xsl:variable name="projTempID">
			        <xsl:choose>
			          <xsl:when test="/webcenter_page/project_list/project/@id">
			          	<xsl:value-of select="/webcenter_page/project_list/project/@id"/>
			          </xsl:when>
			          <xsl:otherwise>
			          	<xsl:value-of select="/webcenter_page/template_list/project_list/project/@id"/>
			          </xsl:otherwise>
			        </xsl:choose>
			    </xsl:variable>
			    
			    var currentUser = ObjectHandler.getCloneOfObject(gCurrentUser);
				currentUser.canEditAttributes = <xsl:value-of select="$isEditable"/>;
		
				var readURL = "GetAttributeCategoryXML.jsp?categoryid=" + '<xsl:value-of select="/webcenter_page/doc_version/category_id"/>';
				// ensure to only append the category's mod date when it is known
				<xsl:if test="/webcenter_page/category/mod_time_stamp">
					readURL  += '&amp;lastmodified='+ <xsl:value-of select="/webcenter_page/category/mod_time_stamp"/> ;
				</xsl:if>
				var valuesURL = "GetAttributes.jsp?docverid="+'<xsl:value-of select="/webcenter_page/doc_version/@id"/>';
		
				var aCatOptions = new Object();
				aCatOptions.ACatObj = "ACatObj";
				aCatOptions.ACatPanel = "ACatPanel";
				aCatOptions.readURL = readURL;
				aCatOptions.currentUser = currentUser;
				aCatOptions.valuesURL = valuesURL;
				<xsl:if test="count(/webcenter_page/attrcatview)>0">
					aCatOptions.view='<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="/webcenter_page/attrcatview"/></xsl:call-template>';
				</xsl:if>
				aCatOptions.defaultHourAsHalfHours = <xsl:value-of select="/webcenter_page/default_due_date_time"/>;
				aCatOptions.type = "document";
				aCatOptions.projectID = '<xsl:value-of select="$projTempID"/>';
				aCatOptions.documentID = '<xsl:value-of select="/webcenter_page/doc_version/document/@id"/>';
				aCatOptions.docVersionID = '<xsl:value-of select="/webcenter_page/doc_version/@id"/>';
				if (aCatOptions.docVersionID) {
					// to be used to detect cyclic dependencies in document references
					aCatOptions.docTableParentDocVerIDs = [aCatOptions.docVersionID];
				}
				myACat = new AttributeCategory(aCatOptions);

			    // myACat is a global variable that is sometimes overwritten. this is a safe solution
				var docACatObj = myACat;
				
			    // add trigger to warn user when leaving the page with unsaved changes
			    window.onbeforeunload = function() {
			    	if ((docACatObj.attributesChanged === true) &amp;&amp; !docACatObj.submitInProgress) {
			    		return '<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="Lang:getStr(&lk;,'ACatConfirmPageExit')"/></xsl:call-template>';
			    	}
			    };
			});
		});
		</xsl:if>
      <xsl:text disable-output-escaping="yes">//--&gt;</xsl:text>&#xA;
    </script>

    <xsl:call-template name="DocDetailsJavaScript"/> 
	<xsl:call-template name="AttributeTemplateJavaScript"/>	
  </xsl:template>
</xsl:stylesheet>
